package controllers

import (
	"fmt"
	"hongze/hongze_public_api/models"
	"hongze/hongze_public_api/services"
	"hongze/hongze_public_api/utils"
	"os"
	"os/exec"
	"time"
)

type ImageController struct {
	BaseCommonController
}

//
//// @Title 图片上传
//// @Description 图片上传接口
//// @Param   Img   query   string  true       "图片base64字符串"
//// @Param   Sign   query   string  true       "策略组提供的资源id"
//// @Success 200 新增成功
//// @router /svg_to_png [post]
//func (this *ImageController) Base64Upload() {
//	br := new(models.BaseResponse).Init()
//	defer func() {
//		this.Data["json"] = br
//		this.ServeJSON()
//	}()
//	sign := this.GetString("Sign")
//	checkSign := "dIGi2M0VN21s3dKS"
//	if sign != checkSign {
//		br.Msg = "前面错误"
//		return
//	}
//	imgData := this.GetString("Img")
//	if imgData == "" {
//		br.Msg = "图片参数错误"
//		br.ErrMsg = "图片参数错误,Img Is Empty"
//		return
//	}
//	var err error
//	dateDir := time.Now().Format("20060102")
//	uploadDir := "static/imgs/" + dateDir
//
//	if !utils.FileIsExist(uploadDir) {
//		err = os.MkdirAll(uploadDir, 777)
//		if err != nil {
//			br.Msg = "存储目录创建失败"
//			br.ErrMsg = "存储目录创建失败,Err:" + err.Error()
//			return
//		}
//	}
//	var saveToOssPath string
//	randStr := utils.GetRandStringNoSpecialChar(28)
//	var fileName, savePath, svgPath, outPath, outFileName string
//	imgData = strings.Replace(imgData, "data:image/svg+xml;base64,", "", -1)
//	fileName = randStr + ".svg"
//	savePath = uploadDir + "/" + fileName
//	svgPath = savePath
//	err = utils.SaveBase64ToFile(imgData, savePath)
//	if err != nil {
//		br.Msg = "图片保存失败"
//		br.ErrMsg = "图片保存失败,Err:" + err.Error()
//		return
//	}
//
//	outFileName = randStr + ".png"
//	outPath = uploadDir + "/" + randStr + ".png"
//
//	imagick.Initialize()
//	defer imagick.Terminate()
//
//	args := []string{
//		"convert", "-background", "none", "-size", "1200x800", svgPath, outPath,
//	}
//	convertImageCommand, err := imagick.ConvertImageCommand(args)
//	fmt.Println()
//	if err != nil {
//		fmt.Println("imagick.ConvertImageCommand:" + err.Error())
//		br.Msg = "图片保存失败"
//		br.ErrMsg = "图片格式转换失败,Err:" + err.Error()
//		return
//	}
//	fmt.Println(convertImageCommand)
//
//	if outPath != "" {
//		savePath = outPath
//	}
//	fmt.Println("upload path:" + savePath)
//	hzUploadDir := "static/images/"
//	saveToOssPath = hzUploadDir + time.Now().Format("200601/20060102/")
//	saveToOssPath += outFileName
//	//上传到阿里云
//	err = services.UploadFileToAliyun("", savePath, saveToOssPath)
//	if err != nil {
//		br.Msg = "文件上传失败"
//		br.ErrMsg = "文件上传失败，Err:" + err.Error()
//		return
//	}
//	fileHost := "https://hzstatic.hzinsights.com/"
//	resourceUrl := fileHost + saveToOssPath
//	resp := new(models.ResourceResp)
//	resp.ResourceUrl = resourceUrl
//	br.Msg = "上传成功"
//	br.Ret = 200
//	br.Success = true
//	br.Data = resp
//	return
//}

// @Title 图片上传
// @Description 图片上传接口
// @Param   Img   query   string  true       "图片base64字符串"
// @Param   Sign   query   string  true       "策略组提供的资源id"
// @Success 200 新增成功
// @router /svg_to_png [post]
func (this *ImageController) Base64Upload() {
	br := new(models.BaseResponse).Init()
	defer func() {
		this.Data["json"] = br
		this.ServeJSON()
	}()
	sign := this.GetString("Sign")
	checkSign := "dIGi2M0VN21s3dKS"
	if sign != checkSign {
		br.Msg = "签名错误"
		return
	}
	imgData := this.GetString("Img")
	if imgData == "" {
		br.Msg = "图片参数错误"
		br.ErrMsg = "图片参数错误,Img Is Empty"
		return
	}
	var err error
	uploadDir := "static/images/"
	if !utils.FileIsExist(uploadDir) {
		err = os.MkdirAll(uploadDir, 777)
		if err != nil {
			br.Msg = "存储目录创建失败"
			br.ErrMsg = "存储目录创建失败,Err:" + err.Error()
			return
		}
	}
	var saveToOssPath string
	randStr := utils.GetRandStringNoSpecialChar(28)
	var fileName, saveSvgPath, outFileName string
	fileName = randStr + ".svg"
	saveSvgPath = uploadDir + "/" + fileName
	err = utils.SaveToFile(imgData, saveSvgPath)
	if err != nil {
		br.Msg = "图片保存失败"
		br.ErrMsg = "图片保存失败,Err:" + err.Error()
		return
	}
	outFileName = uploadDir + randStr + ".png"
	fmt.Println("start convert", time.Now())
	cd := exec.Command("highcharts-export-server", "--infile", saveSvgPath, "--constr", "Chart", "--scale", "2","--workers","10","--workLimit","5", "--outfile", outFileName)
	str, err := cd.Output()
	fmt.Println(string(str))
	if err != nil {
		fmt.Println("Command Err:" + err.Error())
		return
	}
	fmt.Println("end convert", time.Now())
	defer func() {
		os.Remove(saveSvgPath)
		os.Remove(outFileName)
	}()
	saveToOssPath = uploadDir + time.Now().Format("200601/20060102/")
	saveToOssPath += outFileName
	//上传到阿里云
	fmt.Println("upload:", outFileName, saveToOssPath)
	err = services.UploadFileToAliyun("", outFileName, saveToOssPath)
	if err != nil {
		br.Msg = "文件上传失败"
		br.ErrMsg = "文件上传失败，Err:" + err.Error()
		return
	}
	fileHost := "https://hzstatic.hzinsights.com/"
	resourceUrl := fileHost + saveToOssPath
	resp := new(models.ResourceResp)
	resp.ResourceUrl = resourceUrl
	br.Msg = "上传成功"
	br.Ret = 200
	br.Success = true
	br.Data = resp
	return
}
