package controllers

import (
	"encoding/json"
	"hongze/hongze_public_api/models"
	"hongze/hongze_public_api/services"
	"hongze/hongze_public_api/services/alarm_msg"
)

//发送模板消息
type WechatController struct {
	BaseAuthController
}

// @Title 推送模板消息
// @Description 推送模板消息
// @Success 200 新增成功
// @router /send_template_msg [post]
func (this *WechatController) SendTemplateMsg() {
	br := new(models.BaseResponse).Init()
	defer func() {
		this.Data["json"] = br
		this.ServeJSON()
	}()
	body := this.Ctx.Input.RequestBody
	sendItem := new(models.SendWxTemplate)
	err := json.Unmarshal(body, &sendItem)
	if err != nil {
		br.Msg = "参数解析失败"
		br.ErrMsg = "参数解析失败,Err:" + err.Error()
		return
	}
	go func() {
		err = services.SendWxTemplateMsg(sendItem)
		if err != nil {
			msg := "URI:" + this.Ctx.Input.URI() + "<br/> " + "Params" + string(body) + " <br/>" + "ErrMsg:" + err.Error() + ";<br/> Body:" + string(body) + "<br/>"
			go alarm_msg.SendAlarmMsg(msg, 1)
		}
	}()
	br.Ret = 200
	br.Msg = "推送成功"
	return
}
